/*
Author     :  AA-Team - http://themeforest.net/user/AA-Team
*/
// Initialization and events code for the app
CG_admin = (function ($) {
    "use strict";

    // public
    var debug_level = 0,
        maincontainer = null,
        $action_status = null,
        notices_main = null,
        loading = null,
        notices_opt = {};
    
	// init function, autoload
	(function init() {
		// load the triggers
		$(document).ready(function(){
			maincontainer = $(".CG_iw");
			$action_status = maincontainer.find(".CG-action-status.CG-message");

            notices_main = $("#CG-admin-mainnotices");

			triggers();

			loading = $(".CG_iw-loader");

			fix_content_width();
		});

		$(window).resize(function(){
			fix_content_width();
		});
	})();
	
	function update( data )
	{
		maincontainer.find(".CG_iw-loader").show();
		
		maincontainer.find(".CG_iw-loader").find('span').html('');
		$.ajax({
			url: ajaxurl,
			data: $.extend(
				{
					_ajax_custom_list_nonce: $('#_ajax_custom_list_nonce').val(),
					action: $("#ajaxid").val()
				},
				data
			),
			// Handle the successful result
			success: function( response ) {

				// WP_List_Table::ajax_response() returns json
				var response = $.parseJSON( response );

				// add the requested rows
				if ( response.rows.length )
					maincontainer.find('#the-list').html( response.rows );
					
				// update column headers for sorting
				if ( response.column_headers.length )
					maincontainer.find('thead tr, tfoot tr').html( response.column_headers );
					
				// update pagination for navigation
				if ( response.pagination.bottom.length )
					maincontainer.find('.tablenav.top .tablenav-pages').html( $(response.pagination.top).html() );
					
				if ( response.pagination.top.length )
					maincontainer.find('.tablenav.bottom .tablenav-pages').html( $(response.pagination.bottom).html() );

				// init back our event handlers
				triggers();
				
				// hide the loader
				maincontainer.find(".CG_iw-loader").fadeOut(250);
			}
		});
	}
	
	function __query( query, variable )
	{
		var vars = query.split("&");
		for ( var i = 0; i <vars.length; i++ ) {
			var pair = vars[ i ].split("=");
			if ( pair[0] == variable )
				return pair[1];
		}
		return false;
	}
	
	function fix_content_width()
	{
		maincontainer.css({
			'height': ( $("#wpwrap").height() - 70 )
		});
	}
	
	function launch_amazon_search( that, search_by )
	{
		maincontainer.find(".CG_iw-loader").show();
		
		var form = that.parents("form").eq(0),
			paged = that.data('paged');
		
		if( parseInt(paged) == 0 ){
			paged = 1;
		}
		
		$.ajax({
			url: ajaxurl,
			dataType: "json",
			method: 'post',
			data: {
				action: 'CG_launch_amz_search',
				search_by: search_by,
				keyword: form.find('input[name="keyword"]').val(),
				node: form.find('select[name="node"]').val(),
				asin: form.find('input[name="product[ASIN]"]').val(),
				paged: paged
			},
			// Handle the successful result
			success: function( response ) {
				
				if( response.status == 'valid' ) {

    				if( search_by != "asin" ){
    					$("#CG-dropdown-amazon-selector").html( response.html ).show();
    				}

    				else if ( search_by == "asin" ){
    					$(".CG-product-details").each(function(){
    						var form = $(this);
    						
    						form.find('input[name="product[Title]"]').val( response.product.Title );
    						form.find('input[name="product[Brand]"]').val( response.product.Brand );
    						form.find('input[name="product[DetailPageURL]"]').val( response.product.DetailPageURL );
    						form.find('input[name="product[SmallImage]"]').val( response.product.SmallImage );
    						form.find('input[name="product[Binding]"]').val( response.product.Binding );
    						form.find('input[name="product[ListPrice]"]').val( response.product.ListPrice );
    						form.find('input[name="product[OfferSummary]"]').val( response.product.OfferSummary );
    					});
    				}
				} else {
				    $action_status.html( response.html )
				        .removeClass('CG-success').addClass('CG-error')
				        .show();
				}
				
				// hide the loader
				maincontainer.find(".CG_iw-loader").fadeOut(250);
			}
		});
	}


    /* BEGIN aa-framework */
    function make_tabs()
    {
    	function show_tab_elements( link, form, that )
    	{
    		var link_name = link.find("a").attr("href").replace("#", "");

    		// hide all elements
    		form.find( ".CG-form-row:not(." + ( link_name ) + "), .CG-message:not(." + ( link_name ) + ")" ).hide();

    		var cc = 0;
    		form.find( ".CG-form-row." + link_name + ", .CG-message." + link_name ).each(function(){
    			var that = $(this);
    			
    			that.show();

    			if( cc % 2 == 0 ){
    				that.addClass("CG-even");
    			}

    			if( cc % 1 == 0 ){
    				that.addClass("CG-odd");
    			}

    			cc++;
    		});

    		that.find(".on").removeClass("on");
    		link.addClass("on");
    	}

		maincontainer.find(".CG-settings-tabs").each(function(){
			var that = $(this),
				form = that.parents("form").eq(0),
				link = that.find("li").eq(0);

			show_tab_elements( link, form, that );

			that.on('click', 'li a', function(e){
				e.preventDefault();
				var link = $(this).parent("li");
				
				show_tab_elements( link, form, that );
			});
       });
    }
    
    
    function saveOptions($btn)
    {
        var theForm         = $btn.parents('form').eq(0),
            value           = $btn.val(),
            statusBoxHtml   = theForm.find('div#CG-status-box');

        // replace the save button value with loading message
        $btn.val('saving setings ...').removeClass('green').addClass('gray');
        
        theForm.submit();
        
        // replace the save button value with default message
        $btn.val( value ).removeClass('gray').addClass('green');
    }
	
	function build_oauth_url( client_id )
	{
		var oauth_container = $(".CG-tmdb-auth-box"),
			btn 			= oauth_container.find('#CG-tmdb-auth-button'),
			redirect_url	= oauth_container.find("input[name='redirect-url']").val(),
			tmdb_url		= 'https://api.tmdb.com/authorization?response_type=code&client_id={client_id}&redirect_uri={redirect_url}';
		
		var oauth_url = tmdb_url.replace( "{client_id}", client_id );
			oauth_url = oauth_url.replace( "{redirect_url}", redirect_url );
		
		btn.attr("href", oauth_url); 
	}
	
	function same_height( $elms )
	{
		$elms.each(function(){
			var row 		= $(this),
				maxHeight 	= 0,
				childs 		= row.find(">div .CG_iw-dashboard-in-box-content");

			childs.each(function(){
				var that = $(this),
					height = that.height();

				if( maxHeight <= height ){
					maxHeight = height;
				}
			});
			childs.height( maxHeight );
		});
	}

	function font_preview() 
	{
		function change_font( preview_elm ) {
			var that = preview_elm,
				pair_element = that.parents('.CG-form-item:first').find('select'),
				pair_value = pair_element.val(),
				google_font_url = "http://fonts.googleapis.com/css?family=" + pair_value;
			
			// step 1, load into DOM the spreadsheet
			$("head").append("<link href='" + ( google_font_url ) + "' rel='stylesheet' type='text/css'>");
			
			// step 2, print the font name into preview with inline font-family
			that.html( "<span style='font-family: " + ( pair_value ) + "'>Grumpy wizards make toxic brew for the evil Queen and Jack.</span>" );
		};
		
		$(".CG-font-preview").each(function(){
			var that = $(this),
				pair_element = that.parents('.CG-form-item:first').find('select');

			change_font( that );

			pair_element.change(function(e) {
				var preview = $(this).parents('.CG-form-item:first').find('.CG-font-preview');
				change_font( preview );
			});
		});
	};

	function register_plugin( that )
	{
		var form = that.parents('form').eq(0);

		loading.show();
		var data = {
            'action'	: 'CG_register',
			'params'	: form.serialize()
       	};
       	
		$.post(ajaxurl, data, function (response) {
			//console.log(response );
			
			if( response.status == 'valid' ){
				location.reload();
			}
			else {
				var formContainer = form.parent('.CG_iw-dashboard-in-box-content');
				formContainer.text('');
				formContainer.append('<p>Invalid IPC. Please retry</p>');
			}

			loading.hide();
			
        }, 'json');
	}

	function user_get_charts() 
	{
		$('#CG-user-chart').each(function() {
			var that = $(this);

			$.ajax({
				url: ajaxurl,
				dataType: "json",
				method: 'post',
				data: {
					action: 'CG_get_user_chart',
					user: $(this).data('user')
				},
				// Handle the successful result
				success: function( response ) {
					if( response.status == 'valid' && response.data.length > 0 ){

						google.charts.load('current', {'packages':['line']});
						google.charts.setOnLoadCallback(drawChart);

						function drawChart() {
							var responseData = response.data;

							// Create the data table.
							var data = new google.visualization.DataTable();

							data.addColumn('string', 'Contest Name');
      						data.addColumn('number', 'Obtained Points');

							responseData.forEach(function(entry) {
								data.addRow([entry['contest_name'], parseInt(entry['obtained_points'])]);
							});
							
							var options = {
								chart: {
									title: 'Obtained Points',
									subtitle: 'for the contests played'
								},
								width: 900,
								height: 500
							};

							var chart = new google.charts.Line(document.getElementById('CG-user-chart'));

							chart.draw(data, google.charts.Line.convertOptions(options));
						}
					}
					else {
						that.text('No statistics for this user.');
					}
				}  
			});
		});
	}

	function triggers()
	{
		same_height( maincontainer.find(".CG_iw-section-dashboard-row") );
        make_tabs();

        user_get_charts();
		
		$('body').on('click', ".CG-tmdb-auth-box-header a:not(.on)", function(e){
			e.preventDefault();
			var that = $(this),
				rel = $(that.attr('href')),
				preload = $(".CG-tmdb-auth-containers .CG_iw-loader");
				
			preload.show();
			
			$(".CG-tmdb-auth-box-header a.on").removeClass("on");
			$(".CG-tmdb-tab-auth").hide();
			rel.show();
			
			if( that.attr('href') == '#CG-tmdb-auth-tab-user' ){
				$.ajax({
					url: ajaxurl,
					dataType: "json",
					method: 'post',
					data: {
						action: 'CG_Envato_ajax',
						sub_action: "get_account"
					},
					// Handle the successful result
					success: function( response ) {
						if( response.status == 'valid' ){
							rel.html( response.html ); 
							preload.hide();
						}
					}
				});
				
			}
			else{
				preload.hide();
			}
			that.addClass('on');
		});
		
		if( $('.CG-tmdb-auth-box-header').data('default') == 'ok' ){
			$('.CG-tmdb-auth-box-header a').eq(1).click();
		}else{
			$('.CG-tmdb-auth-box-header a').eq(0).click();
		}
		
		$('body').on('click', 'button.CG-add-btn', function(e){
			e.preventDefault();
			add_product( $(this) );
		});
		
		$('body').on('click', '#CG-search-on-amazon, .CG-items-pagination button, .CG-find-product-by-id', function(e){
			e.preventDefault();
			
			var that = $(this),
				type = 'keyword';
			
			if( that.hasClass("CG-find-product-by-id") ){
				type = 'asin';
			}
			 
			launch_amazon_search( that, type );
		});

		// Pagination links, sortable link
		maincontainer.find('.tablenav-pages a, .manage-column.sortable a, .manage-column.sorted a').on('click', function(e) {
			e.preventDefault();
			
			// use the URL to extract our needed variables
			var query = this.search.substring( 1 );
			
			var data = {
				paged: __query( query, 'paged' ) || '1',
				order: __query( query, 'order' ) || 'desc',
				orderby: __query( query, 'orderby' ) || 'id'
			};
  
			update( data );
		});

		// page number input
		maincontainer.find('input[name=paged]').on('keyup', function(e) {

			// If user hit enter, we don't want to submit the form
			if ( 13 == e.which )
				e.preventDefault();

			// This time we fetch the variables in inputs
			var data = {
				paged: parseInt( maincontainer.find('input[name=paged]').val() ) || '1',
				order: maincontainer.find('input[name=order]').val() || 'desc',
				orderby: maincontainer.find('input[name=orderby]').val() || 'id',
				filter_by: maincontainer.find('input[name=filter_by]').val() || 'post',
			};
 
			update( data );
		});
		
		maincontainer.find('select[name=filter_by]').on('change', function(e) {
			var that = $(this),
				val = that.val();
			
			maincontainer.find('select[name=filter_by]').val( val ); 
		});
		
		// bulk actions - Apply
        maincontainer.find('input#doaction').on('click', function(e) {
            e.preventDefault();
            
            var that = $(this),
                form = that.parents('form').eq(0),
                _action = form.find('select#bulk-action-selector-top').val();
 
            // '_ajax_custom_list_nonce', 'ajaxid', 'order', 'orderby', '_wpnonce', '_wp_http_referer'
            var field_reset = ['_ajax_custom_list_nonce', 'ajaxid', 'order', 'orderby', '_wp_http_referer'];
            for (var i in field_reset) {
                $( 'input[name="'+field_reset[i]+'"]' ).remove();
            }
            if ( 'delete' == _action ) {
                $( 'input[name="paged"]' ).val(1);
            }
  
            form.submit();
        });
		
		$('.CG-wp-color-picker').wpColorPicker();
		
        $('body').on('click', '.CG-saveOptions', function(e) {
            e.preventDefault();
            saveOptions( $(this) );
        });
        
        maincontainer.find('#CG-tmdb-auth-button').on('click', function(e) {
        	e.preventDefault();
        	
        	tmdb_auth( $(this) ); 
        });
        
        $('body').on('click', '.CG-show-all-options', function(e) {
            e.preventDefault();
            
            var that = $(this).parents('form').eq(0);
            
            that.find(".we-complex-options").removeClass('we-complex-options');
        });

        maincontainer.find('.CG_iw-register_plugin').on('click', '.CG_iw-dashboard-button', function(e) {
        	e.preventDefault();

        	register_plugin( $(this) );
        });

        maincontainer.on('click', '.CG_iw-require_register', function(e){
        	e.preventDefault();

        	$(".CG_iw-dashboard-input[name='CG_iw-validation-token']").focus();
        });

        maincontainer.find('.CG-select-wrapper').on('click', '.CG-select-item:not(.select-on)', function(e) {
        	e.preventDefault();

        	var that = $(this),
        		parent = that.parent();

        	parent.find(".select-on").removeClass('select-on');
        	parent.find("input").removeAttr("checked");

        	that.addClass('select-on');
        	that.find("input").attr('checked', true);
        });

        font_preview();
	}
	
    var misc = {
        is_chrome: function() {
            return window.chrome;
            //return navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
        }
    }

	// external usage
	return {
		'triggers'                  : triggers,
        'make_tabs'                  : make_tabs
	}
})(jQuery);
