<?php
/**
 * Amazon module return as json_encode
 * http://www.aa-team.com
 * =======================
 *
 * @author		Andrei Dinca, AA-Team
 * @version		1.0
 */
echo json_encode(array(
	// create the box elements array
	'option_name' => 'CG_Import_Settings',

	'tabs' => array(
		'frontend' => array(
			'label' 	=> 'Frontend Settings',
			'elements' 	=> 'generator_page, contests_per_page, main_heading_color, main_heading_border, main_heading_family, main_heading_fontsize, subheading_color, subheading_family, subheading_fontsize, description_color, description_family, description_fontsize, button_background_color, button_font_color, button_family, button_fontsize, background_color'
		)
	),

	'elements' => array(

		'generator_page' => array(
	        'type' => 'select',
	        'std' => function_exists('CG') ? CG()->get_pages( true ) : '',
	        'size' => 'small',
	        'title' => 'Contest Page',
	        'force_width' => '320',
	        'options' => function_exists('CG') ? CG()->get_pages() : array(),
	        'desc' => 'Select the website page to display the contest generator page.'
	    ),

	    'contests_per_page' => array(
	        'type' => 'text',
	        'std' => '6',
	        'size' => 'small',
	        'title' => 'Number Of Contests Per Page',
	        'force_width' => '260',
	        'desc' => 'Displayed number of contests per page'
	    ),

	    'main_heading_color' => array(
	        'type' => 'color_picker',
	        'std' => '#fff',
	        'size' => 'small',
	        'title' => 'Main Heading Color',
	        'force_width' => '260',
	        'desc' => 'The template main heading color on contest details.'
	    ),

	    'main_heading_border' => array(
	        'type' => 'color_picker',
	        'std' => '#fff',
	        'size' => 'small',
	        'title' => 'Main Heading Border',
	        'force_width' => '260',
	        'desc' => 'The template main heading border color on contest details.'
	    ),


	    'main_heading_family' => array(
	        'type'				=> 'select',
	        'std'				=> 'Passion One',
	        'options' 			=> function_exists('CG') ? CG()->getAllGfonts() : array(),
	        'title'				=> 'Main Heading Font Family',
	        'desc'				=> '<div class="CG-font-preview"></div>',
	        'size'				=> 'small'
	    ),

	    'main_heading_fontsize' => array(
	        'type' => 'text',
	        'std' => '30px',
	        'size' => 'small',
	        'title' => 'Main Heading Font Size',
	        'force_width' => '260',
	        'desc' => 'The template main heading fontsize.'
	    ),

	    'subheading_color' => array(
	        'type' => 'color_picker',
	        'std' => '#787878',
	        'size' => 'small',
	        'title' => 'Subheading Color',
	        'force_width' => '260',
	        'desc' => 'The SubHeading Color'
	    ),

	    'subheading_family' => array(
	        'type'				=> 'select',
	        'std'				=> 'Chewy',
	        'options' 			=> function_exists('CG') ? CG()->getAllGfonts() : array(),
	        'title'				=> 'Sub Heading Font Family',
	        'desc'				=> '<div class="CG-font-preview"></div>',
	        'size'				=> 'small'
	    ),

	    'subheading_fontsize' => array(
	        'type' => 'text',
	        'std' => '16px',
	        'size' => 'small',
	        'title' => 'Sub Heading Font Size',
	        'force_width' => '260',
	        'desc' => 'The template sub heading font size'
	    ),

	    'description_color' => array(
	        'type' => 'color_picker',
	        'std' => '#fff',
	        'size' => 'small',
	        'title' => 'Contest Description Color',
	        'force_width' => '260',
	        'desc' => 'The template description color'
	    ),

	    'description_family' => array(
	        'type'				=> 'select',
	        'std'				=> 'Poppins',
	        'options' 			=> function_exists('CG') ? CG()->getAllGfonts() : array(),
	        'title'				=> 'The Description Font Family',
	        'desc'				=> '<div class="CG-font-preview"></div>',
	        'size'				=> 'small'
	    ),

	    'description_fontsize' => array(
	        'type' => 'text',
	        'std' => '14px',
	        'size' => 'small',
	        'title' => 'The Description Font Size',
	        'force_width' => '260',
	        'desc' => 'The template description font size'
	    ),

	    'button_background_color' => array(
	        'type' => 'color_picker',
	        'std' => '#6fba3d',
	        'size' => 'small',
	        'title' => 'Buttons Background Color',
	        'force_width' => '260',
	        'desc' => 'Your template button background color'
	    ),
	    'button_font_color' => array(
	        'type' => 'color_picker',
	        'std' => '#fff',
	        'size' => 'small',
	        'title' => 'Buttons Color',
	        'force_width' => '260',
	        'desc' => 'The template button font color'
	    ),

	    'button_family' => array(
	        'type'				=> 'select',
	        'std'				=> 'Poppins',
	        'options' 			=> function_exists('CG') ? CG()->getAllGfonts() : array(),
	        'title'				=> 'Buttons Font',
	        'desc'				=> '<div class="CG-font-preview"></div>',
	        'size'				=> 'small'
	    ),

	    'button_fontsize' => array(
	        'type' => 'text',
	        'std' => '13px',
	        'size' => 'small',
	        'title' => 'Buttons Font Size',
	        'force_width' => '260',
	        'desc' => 'The template button fontsize'
	    ),

	    'background_color' => array(
	        'type' => 'color_picker',
	        'std' => '#303437',
	        'size' => 'small',
	        'title' => 'Main Container Background Color',
	        'force_width' => '260',
	        'desc' => 'The template contest container color'
	    )		

	    

	), // end elements
));