<?php
require_once('load.wp.php'); // load wordpress
require_once('load.plugin.php'); // load plugin!

error_reporting(E_ALL);
ini_set('display_errors', 1);

/*
* Define class aafShortcodes
* Make sure you skip down to the end of this file, as there are a few
* lines of code that are very important.
*/
!defined('ABSPATH') and exit;

if (class_exists('aafShortcodesPopup') != true) {
    class aafShortcodesPopup
    {

        /*
        * Some required plugin information
        */
        const VERSION = '1.0';

        /*
        * Store some helpers config
        */
		public $the_plugin = null;
		static protected $_instance;
		
		protected $module_folder = '';
		protected $module_folder_path = '';

        /*
        * Required __construct() function that initalizes the AA-Team Framework
        */
        public function __construct()
        {
        	$this->the_plugin = CG();

			$this->module_folder = $this->the_plugin->path('APP_URL')  . 'include/shortcodes/';
			$this->module_folder_path = $this->the_plugin->path( 'SHORTCODES_DIR' );

			$this->buildHtmlPage();
		}
		
		private function buildHtmlPage() {
			$req = array(
				'module'	=> isset($_GET['module']) ? trim($_GET['module']) : '',
				'shortcode'	=> isset($_GET['shortcode']) ? trim($_GET['shortcode']) : '',
			);

				
			?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
			<html xmlns="http://www.w3.org/1999/xhtml">
			<head></head>
			<body>
			
			<script type="text/javascript" src="<?php echo $this->module_folder;?>js/tinymce.popup.js" ></script>
			<link rel='stylesheet' href='<?php echo $this->module_folder;?>css/tinymce.popup.css' type='text/css' media='all' />
			<div class="CG-shortcode-pop-up">
			
				<?php

				$terms = get_terms( 'contests', array(
					'orderby'    => 'count',
					'hide_empty' => 0
				) );

				//die( var_dump( "<pre>", $terms  , "<pre>" ) . PHP_EOL .  __FILE__ . ":" . __LINE__  ); 

				if ( count($terms) > 0 ) {
					echo '<ul class="' . ( $this->the_plugin->alias )  . '-contest-list">';

					foreach( $terms as $term ) {
					//die( var_dump( "<pre>", $term            , "<pre>" ) . PHP_EOL .  __FILE__ . ":" . __LINE__  ); 
						$contest = get_term_meta($term->term_id);
						//die( var_dump( "<pre>", $contest  , "<pre>" ) . PHP_EOL .  __FILE__ . ":" . __LINE__  ); 
						// output the post titles in a list
						echo '<li class="' . ( $this->the_plugin->alias  )  . '-contest-wrapper">';
						 
						echo 	'<div id="' . ( $this->the_plugin->alias )  . '">';
						echo		'<div class="' . ( $this->the_plugin->alias )  . '-wrapper">';
						echo	 		'<div class="' . ( $this->the_plugin->alias )  . '-body ' . ( $this->the_plugin->alias )  . '-intro">';
						echo 				'<div class="' . ( $this->the_plugin->alias )  . '-contest-content">';
						echo 					'<div class="' . ( $this->the_plugin->alias )  . '-media">';

						$image_id = get_term_meta ( $term -> term_id, 'contest-image-id', true ); 
						
						$image_src = wp_get_attachment_image_src ( $image_id, 'thumbnail' ); 

						echo 						'<img src="' . $image_src[0] .'">';
						echo					'</div>';
						echo 					'<div class="' . ( $this->the_plugin->alias )  . '-text">';
						echo 						'<h3 class="' . ( $this->the_plugin->alias )  . '-title">' . $term->name .'</h3>';
						echo 						'<h6 class="' . ( $this->the_plugin->alias )  . '-duration">Availibility: ' . ( date( "d F Y", strtotime($contest['start_game_date'][0]) ) ) . ' - ' . ( date( "d F Y", strtotime($contest['end_game_date'][0])) ) . '</h6>';
						echo					'<div class="' . ( $this->the_plugin->alias )  . '-intro-text">';
						echo						'<p>' . $term->description . '</p>';
						echo					'</div>';
						echo 					'<button data-contestid=' . $term->term_id .' class="' . ( $this->the_plugin->alias )  . '-button ' . ( $this->the_plugin->alias )  . '-insert-shortcode">' . __('Insert Shortcode', $this->the_plugin->localizationName) . '</button>';
						echo	'</div>';
						echo		'</div>';
						echo		'</div>';
						echo		'</div>';
						echo		'</div>';

						echo '</li>';
						 

					}

					echo '</ul>';
				
				} else {

					echo '<div>' . __('No contests at the moment.', $this->the_plugin->localizationName) . '</div>';
				}
				?>

			</div>

			</body>
			</html>
			<?php
		}


        /**
	    * Singleton pattern
	    *
	    * @return Singleton instance
	    */
	    static public function getInstance()
	    {
	        if (!self::$_instance) {
	            self::$_instance = new self;
	        }
	        
	        return self::$_instance;
	    }
    }
}

// Initialize the aafShortcodesPopup class
$aafShortcodesPopup = new aafShortcodesPopup();